import 'dart:ffi';

import 'dart:io';

/// Platform specific operations on [DynamicLibrary]
extension PlatformSpecific on DynamicLibrary {
  /// Platform specific file extension for dynamic libraries
  static String extension = () {
    if (Platform.isLinux || Platform.isAndroid) return '.so';
    if (Platform.isMacOS) return '.dylib';
    if (Platform.isWindows) return '.dll';
    throw UnsupportedError('Platform is not supported');
  }();

  /// [name] is the name of the dynamic library without its file extension
  static DynamicLibrary open(String name) {
    return DynamicLibrary.open(name + extension);
  }
}
