import 'dart:ffi';

import 'package:ffi_helper/ffi_helper.dart';
import 'shared_array.dart';

/// References a [SharedArray] without influencing the reference count.
class WeakArray<T extends NativeType> with Array<T> {
  final SharedArray<T> _shared;
  bool get deleted => _shared.deleted;
  @override
  Pointer<T> get ptr => _shared.ptr;
  @override
  int get length => _shared.length;
  WeakArray(this._shared);

  /// Converts [this] to a [SharedArray]
  SharedArray<T> toShared() => _shared.newShared();

  /// Doesn't do anything
  @override
  void delete() {}
}
